import { BlankNode, DataFactory, DatasetCore, Literal, NamedNode, Quad, Term } from '@rdfjs/types';
import type { Environment } from '@rdfjs/environment/Environment.js';
import type { TermMapFactory } from '@rdfjs/term-map/Factory.js';
import { Value } from './value.js';
import { PartialString, SerializationStrategy, TemplateResult } from './TemplateResult.js';
export interface NQuadsOptions {
    env: Environment<DataFactory | TermMapFactory>;
    sortGraphs: boolean;
}
export type NQuadsTemplateResult = TemplateResult<NQuadsOptions>;
export type NQuadsValue<T extends Term = Term> = Value<NQuadsTemplateResult, T>;
export declare class NQuadsStrategy<TOptions extends NQuadsOptions = NQuadsOptions> extends SerializationStrategy<TOptions> {
    evaluateDataset(dataset: DatasetCore, options: TOptions): PartialString;
    evaluateQuad(quad: Quad, options: TOptions): PartialString;
    evaluateLiteral(term: Literal): PartialString;
    evaluateNamedNode(term: NamedNode): PartialString;
    evaluateBlankNode(term: BlankNode): PartialString;
    evaluateVariable(): PartialString;
    getFinalString(result: string): string;
}
export declare const nquads: (strings: TemplateStringsArray, ...values: Value<TemplateResult<NQuadsOptions>, NamedNode | Literal | BlankNode>[]) => NQuadsTemplateResult;
//# sourceMappingURL=nquads.d.ts.map