import { NQuadsStrategy } from './nquads.js';
import { TemplateResult } from './TemplateResult.js';
export class NTriplesStrategy extends NQuadsStrategy {
    evaluateDataset(dataset, options) {
        const singleGraph = dataset.match(null, null, null, options.graph);
        return super.evaluateDataset(singleGraph, options);
    }
    evaluateQuad(quad, options) {
        if (!options.graph.equals(quad.graph)) {
            return {
                value: '',
                prefixes: [],
            };
        }
        return super.evaluateQuad(options.env.quad(quad.subject, quad.predicate, quad.object), options);
    }
}
export const ntriples = (strings, ...values) => new TemplateResult({
    strings,
    values,
    tag: ntriples,
    strategy: new NTriplesStrategy(),
    defaultOptions: (RDF) => ({
        graph: RDF.defaultGraph(),
        sortGraphs: false,
    }),
});
